Loading...
Searching...
No Matches
casacore::RegionManager Class Reference

`#include <RegionManager.h>`

## Public Member Functions

| RegionManager ()
| blank constructor
| RegionManager (const CoordinateSystem &csys)
virtual | ~RegionManager ()
String | absreltype (const Int absrelval=0)
void | setcoordsys (const CoordinateSystem &csys)
const CoordinateSystem & | getcoordsys () const
Record * | box (const Vector< Double > &blc, const Vector< Double > &trc, const Vector< Double > &inc, const String &absrel, const Bool frac, const String &comment="")
| LCSlicer box.
Record * | wbox (const Vector< Quantity > &blc, const Vector< Quantity > &trc, const Vector< Int > &pixelaxes, const CoordinateSystem &csys, const String &absrel, const String &comment)
Record * | wbox (const Vector< String > &blc, const Vector< String > &trc, const Vector< Int > &pixelaxes, const CoordinateSystem &csys, const String &absrel, const String &comment)
Record * | wbox (const Vector< Quantity > &blc, const Vector< Quantity > &trc, const Vector< Int > &pixelaxes, const String &absrel, const String &comment)
Record * | wbox (const Vector< String > &blc, const Vector< String > &trc, const Vector< Int > &pixelaxes, const String &absrel, const String &comment)
ImageRegion * | wbox (const Vector< Quantity > &blc, const Vector< Quantity > &trc, const Vector< Int > &pixelaxes, const CoordinateSystem &csys, const String &absrel="abs")
ImageRegion * | wpolygon (const Vector< Quantity > &x, const Vector< Quantity > &y, const Vector< Int > &pixelaxes, const CoordinateSystem &csys, const String &absrel)
| Wpolygon with coordsys and if pixelaxes[0] is -1 then its assumed to be 0,1,...
ImageRegion * | wpolygon (const Vector< Quantity > &x, const Vector< Quantity > &y, const Vector< Int > &pixelaxes, const String &absrel)
| wpolygon version without csys...throws an exception if setcoordsys is not run
ImageRegion * | wellipse (const Quantity &xc, const Quantity &yc, const Quantity &a, const Quantity &b, const Quantity &pa, const uInt pixelAxis0, const uInt pixelAxis1, const String &absrel) const
| wellipse version without csys...throws an exception if setcoordsys is not run
ImageRegion * | wsphere (const Vector< Quantity > &center, const Quantity &radius, const Vector< Int > &pixelaxes, const String &absrel) const
| wsphere version without csys...throws an exception if setcoordsys is not run
ImageRegion * | wellipsoid (const Vector< Quantity > &center, const Vector< Quantity > &radii, const Vector< Int > &pixelaxes, const String &absrel) const
ImageRegion * | wshell (const Vector< Quantity > &center, const Vector< Quantity > &innerRadii, const Vector< Quantity > &outerRadii, const Vector< Int > &pixelaxes, const String &absrel) const
ImageRegion * | doComplement (const WCRegion &reg1)
| Various versions of creating a complement region.
ImageRegion * | doComplement (const PtrBlock< const WCRegion * > &reg1)
ImageRegion * | doComplement (const ImageRegion &reg1)
ImageRegion * | doConcatenation (const WCRegion &region, const WCBox &box)
| Various versions of concatenating a region onto another.
ImageRegion * | doconcatenation (const PtrBlock< const WCRegion * > &regions, const WCBox &box)
ImageRegion * | doConcatenation (const PtrBlock< const ImageRegion * > &regions, const TableRecord &box)
ImageRegion * | doConcatenation (const Record &regions, const TableRecord &box)
ImageRegion * | doDifference (const WCRegion &reg1, const WCRegion &reg2)
| Various versions of handling the difference of regions.
ImageRegion * | doDifference (const PtrBlock< const WCRegion * > &reg1)
ImageRegion * | doDifference (const ImageRegion &reg1, const ImageRegion &reg2)
ImageRegion * | doIntersection (const WCRegion &reg1, const WCRegion &reg2)
| Different versions of intersecting regions.
ImageRegion * | doIntersection (const PtrBlock< const WCRegion * > &reg1)
ImageRegion * | doIntersection (const ImageRegion &reg1, const ImageRegion &reg2)
ImageRegion * | doUnion (const WCRegion &reg1, const WCRegion &reg2)
| Different versions of unioning regions.
ImageRegion * | doUnion (const PtrBlock< const WCRegion * > &reg1)
ImageRegion * | doUnion (const ImageRegion &reg1, const ImageRegion &reg2) const
String | imageRegionToTable (const String &tabName, const ImageRegion &imreg, const String &regName, Bool asmask=False)
| save region into a table (image, blank table or any other such)
String | recordToTable (const String &tabName, const RecordInterface &rec, const String &regName="", Bool asmask=False)
Record * | tableToRecord (const String &tabName, const String &regname)
| recover region from table
Vector< String > | namesInTable (const String &tabName)
| names of regions in table
Bool | removeRegionInTable (const String &tabName, const String &regName)
| Remove a region from table...refuse is regionname is "".

## Static Public Member Functions

static Bool | isPixelRegion (const ImageRegion &reg)
| Some little but useful tidbits.
static Bool | isWorldRegion (const ImageRegion &reg)
static Record * | box (const Vector< Double > &blc, const Vector< Double > &trc, const Vector< Int > &shape, const String &comment="")
| LCBox box.
static ImageRegion * | wellipse (const Quantity &xc, const Quantity &yc, const Quantity &a, const Quantity &b, const Quantity &pa, const uInt pixelAxis0, const uInt pixelAxis1, const CoordinateSystem &csys, const String &absrel)
static ImageRegion * | wsphere (const Vector< Quantity > &center, const Quantity &radius, const Vector< Int > &pixelaxes, const CoordinateSystem &csys, const String &absrel)
static ImageRegion * | wellipsoid (const Vector< Quantity > &center, const Vector< Quantity > &radii, const Vector< Int > &pixelaxes, const CoordinateSystem &csys, const String &absrel)
static ImageRegion * | wshell (const Vector< Quantity > &center, const Vector< Quantity > &innerRadii, const Vector< Quantity > &outerRadii, const Vector< Int > &pixelaxes, const CoordinateSystem &csys, const String &absrel)
static ImageRegion * | wmask (const String &command)
static Record * | readImageFile (String filename, String regionname)
| Reading of a file containing an ImageRegion in the AipsIO format dump.
static Bool | writeImageFile (const String &file, const String &regionname, const Record &regionRecord)
| Writing a file of the AipsIO dump of the record representation of the region.

## Protected Member Functions

LogIO * | _getLog () const

## Private Member Functions

void | toQuantity (Quantity &out, const String &in)
| Convert a string to Quantity.

## Static Private Member Functions

static Table & | getTable (void *ptr, Bool writable)
| Function to return the internal Table object to the RegionHandler.

## Private Attributes

LogIO * | itsLog
std::unique_ptr< CoordinateSystem > | itsCSys
Table | tab_p

## Detailed Description

Definition at line 56 of file RegionManager.h.

## Constructor & Destructor Documentation

## RegionManager() [1/2]

casacore::RegionManager::RegionManager | ( |  | ) |

blank constructor

## RegionManager() [2/2]

casacore::RegionManager::RegionManager | ( | const CoordinateSystem & | csys | ) |

## ~RegionManager()

virtual casacore::RegionManager::~RegionManager | ( |  | ) |

virtual

## Member Function Documentation

## _getLog()

LogIO * casacore::RegionManager::_getLog | ( |  | ) | const

inline protected

Definition at line 258 of file RegionManager.h.

References itsLog.

## absreltype()

String casacore::RegionManager::absreltype | ( | const Int | absrelval = 0 | ) |

## box() [1/2]

Record * casacore::RegionManager::box | ( | const Vector< Double > & | blc,
|  | const Vector< Double > & | trc,
|  | const Vector< Double > & | inc,
|  | const String & | absrel,
|  | const Bool | frac,
|  | const String & | comment = "" )

LCSlicer box.

References casacore::comment(), and casacore::Record().

Referenced by doConcatenation(), doConcatenation(), doConcatenation(), and doconcatenation().

## box() [2/2]

Record * casacore::RegionManager::box | ( | const Vector< Double > & | blc,
|  | const Vector< Double > & | trc,
|  | const Vector< Int > & | shape,
|  | const String & | comment = "" )

static

LCBox box.

References casacore::comment(), casacore::Record(), and casacore::shape().

## doComplement() [1/3]

ImageRegion * casacore::RegionManager::doComplement | ( | const ImageRegion & | reg1 | ) |

## doComplement() [2/3]

ImageRegion * casacore::RegionManager::doComplement | ( | const PtrBlock< const WCRegion * > & | reg1 | ) |

## doComplement() [3/3]

ImageRegion * casacore::RegionManager::doComplement | ( | const WCRegion & | reg1 | ) |

Various versions of creating a complement region.

## doConcatenation() [1/3]

ImageRegion * casacore::RegionManager::doConcatenation | ( | const PtrBlock< const ImageRegion * > & | regions,
|  | const TableRecord & | box )

References box().

## doConcatenation() [2/3]

ImageRegion * casacore::RegionManager::doConcatenation | ( | const Record & | regions,
|  | const TableRecord & | box )

References box(), and casacore::Record().

## doConcatenation() [3/3]

ImageRegion * casacore::RegionManager::doConcatenation | ( | const WCRegion & | region,
|  | const WCBox & | box )

Various versions of concatenating a region onto another.

References box().

## doconcatenation()

ImageRegion * casacore::RegionManager::doconcatenation | ( | const PtrBlock< const WCRegion * > & | regions,
|  | const WCBox & | box )

References box().

## doDifference() [1/3]

ImageRegion * casacore::RegionManager::doDifference | ( | const ImageRegion & | reg1,
|  | const ImageRegion & | reg2 )

## doDifference() [2/3]

ImageRegion * casacore::RegionManager::doDifference | ( | const PtrBlock< const WCRegion * > & | reg1 | ) |

## doDifference() [3/3]

ImageRegion * casacore::RegionManager::doDifference | ( | const WCRegion & | reg1,
|  | const WCRegion & | reg2 )

Various versions of handling the difference of regions.

## doIntersection() [1/3]

ImageRegion * casacore::RegionManager::doIntersection | ( | const ImageRegion & | reg1,
|  | const ImageRegion & | reg2 )

## doIntersection() [2/3]

ImageRegion * casacore::RegionManager::doIntersection | ( | const PtrBlock< const WCRegion * > & | reg1 | ) |

## doIntersection() [3/3]

ImageRegion * casacore::RegionManager::doIntersection | ( | const WCRegion & | reg1,
|  | const WCRegion & | reg2 )

Different versions of intersecting regions.

## doUnion() [1/3]

ImageRegion * casacore::RegionManager::doUnion | ( | const ImageRegion & | reg1,
|  | const ImageRegion & | reg2 ) const

## doUnion() [2/3]

ImageRegion * casacore::RegionManager::doUnion | ( | const PtrBlock< const WCRegion * > & | reg1 | ) |

## doUnion() [3/3]

ImageRegion * casacore::RegionManager::doUnion | ( | const WCRegion & | reg1,
|  | const WCRegion & | reg2 )

Different versions of unioning regions.

## getcoordsys()

const CoordinateSystem & casacore::RegionManager::getcoordsys | ( |  | ) | const

## getTable()

Table & casacore::RegionManager::getTable | ( | void * | ptr,
|  | Bool | writable )

static private

Function to return the internal Table object to the RegionHandler.

## imageRegionToTable()

String casacore::RegionManager::imageRegionToTable | ( | const String & | tabName,
|  | const ImageRegion & | imreg,
|  | const String & | regName,
|  | Bool | asmask = False )

save region into a table (image, blank table or any other such)

References casacore::False.

## isPixelRegion()

Bool casacore::RegionManager::isPixelRegion | ( | const ImageRegion & | reg | ) |

static

Some little but useful tidbits.

## isWorldRegion()

Bool casacore::RegionManager::isWorldRegion | ( | const ImageRegion & | reg | ) |

static

## namesInTable()

Vector< String > casacore::RegionManager::namesInTable | ( | const String & | tabName | ) |

names of regions in table

## readImageFile()

Record * casacore::RegionManager::readImageFile | ( | String | filename,
|  | String | regionname )

static

Reading of a file containing an ImageRegion in the AipsIO format dump.

References casacore::Record().

## recordToTable()

String casacore::RegionManager::recordToTable | ( | const String & | tabName,
|  | const RecordInterface & | rec,
|  | const String & | regName = "",
|  | Bool | asmask = False )

References casacore::False, and casacore::RecordInterface().

## removeRegionInTable()

Bool casacore::RegionManager::removeRegionInTable | ( | const String & | tabName,
|  | const String & | regName )

Remove a region from table...refuse is regionname is "".

## setcoordsys()

void casacore::RegionManager::setcoordsys | ( | const CoordinateSystem & | csys | ) |

## tableToRecord()

Record * casacore::RegionManager::tableToRecord | ( | const String & | tabName,
|  | const String & | regname )

recover region from table

References casacore::Record().

## toQuantity()

void casacore::RegionManager::toQuantity | ( | Quantity & | out,
|  | const String & | in )

private

Convert a string to Quantity.

## wbox() [1/5]

Record * casacore::RegionManager::wbox | ( | const Vector< Quantity > & | blc,
|  | const Vector< Quantity > & | trc,
|  | const Vector< Int > & | pixelaxes,
|  | const CoordinateSystem & | csys,
|  | const String & | absrel,
|  | const String & | comment )

References casacore::comment(), and casacore::Record().

## wbox() [2/5]

ImageRegion * casacore::RegionManager::wbox | ( | const Vector< Quantity > & | blc,
|  | const Vector< Quantity > & | trc,
|  | const Vector< Int > & | pixelaxes,
|  | const CoordinateSystem & | csys,
|  | const String & | absrel = "abs" )

## wbox() [3/5]

Record * casacore::RegionManager::wbox | ( | const Vector< Quantity > & | blc,
|  | const Vector< Quantity > & | trc,
|  | const Vector< Int > & | pixelaxes,
|  | const String & | absrel,
|  | const String & | comment )

References casacore::comment(), and casacore::Record().

## wbox() [4/5]

Record * casacore::RegionManager::wbox | ( | const Vector< String > & | blc,
|  | const Vector< String > & | trc,
|  | const Vector< Int > & | pixelaxes,
|  | const CoordinateSystem & | csys,
|  | const String & | absrel,
|  | const String & | comment )

References casacore::comment(), and casacore::Record().

## wbox() [5/5]

Record * casacore::RegionManager::wbox | ( | const Vector< String > & | blc,
|  | const Vector< String > & | trc,
|  | const Vector< Int > & | pixelaxes,
|  | const String & | absrel,
|  | const String & | comment )

References casacore::comment(), and casacore::Record().

## wellipse() [1/2]

ImageRegion * casacore::RegionManager::wellipse | ( | const Quantity & | xc,
|  | const Quantity & | yc,
|  | const Quantity & | a,
|  | const Quantity & | b,
|  | const Quantity & | pa,
|  | const uInt | pixelAxis0,
|  | const uInt | pixelAxis1,
|  | const CoordinateSystem & | csys,
|  | const String & | absrel )

static

References casacore::pa().

## wellipse() [2/2]

ImageRegion * casacore::RegionManager::wellipse | ( | const Quantity & | xc,
|  | const Quantity & | yc,
|  | const Quantity & | a,
|  | const Quantity & | b,
|  | const Quantity & | pa,
|  | const uInt | pixelAxis0,
|  | const uInt | pixelAxis1,
|  | const String & | absrel ) const

wellipse version without csys...throws an exception if setcoordsys is not run

References casacore::pa().

## wellipsoid() [1/2]

ImageRegion * casacore::RegionManager::wellipsoid | ( | const Vector< Quantity > & | center,
|  | const Vector< Quantity > & | radii,
|  | const Vector< Int > & | pixelaxes,
|  | const CoordinateSystem & | csys,
|  | const String & | absrel )

static

## wellipsoid() [2/2]

ImageRegion * casacore::RegionManager::wellipsoid | ( | const Vector< Quantity > & | center,
|  | const Vector< Quantity > & | radii,
|  | const Vector< Int > & | pixelaxes,
|  | const String & | absrel ) const

## wmask()

ImageRegion * casacore::RegionManager::wmask | ( | const String & | command | ) |

static

## wpolygon() [1/2]

ImageRegion * casacore::RegionManager::wpolygon | ( | const Vector< Quantity > & | x,
|  | const Vector< Quantity > & | y,
|  | const Vector< Int > & | pixelaxes,
|  | const CoordinateSystem & | csys,
|  | const String & | absrel )

Wpolygon with coordsys and if pixelaxes[0] is -1 then its assumed to be 0,1,...

## wpolygon() [2/2]

ImageRegion * casacore::RegionManager::wpolygon | ( | const Vector< Quantity > & | x,
|  | const Vector< Quantity > & | y,
|  | const Vector< Int > & | pixelaxes,
|  | const String & | absrel )

wpolygon version without csys...throws an exception if setcoordsys is not run

## writeImageFile()

Bool casacore::RegionManager::writeImageFile | ( | const String & | file,
|  | const String & | regionname,
|  | const Record & | regionRecord )

static

Writing a file of the AipsIO dump of the record representation of the region.

References casacore::Record().

## wshell() [1/2]

ImageRegion * casacore::RegionManager::wshell | ( | const Vector< Quantity > & | center,
|  | const Vector< Quantity > & | innerRadii,
|  | const Vector< Quantity > & | outerRadii,
|  | const Vector< Int > & | pixelaxes,
|  | const CoordinateSystem & | csys,
|  | const String & | absrel )

static

## wshell() [2/2]

ImageRegion * casacore::RegionManager::wshell | ( | const Vector< Quantity > & | center,
|  | const Vector< Quantity > & | innerRadii,
|  | const Vector< Quantity > & | outerRadii,
|  | const Vector< Int > & | pixelaxes,
|  | const String & | absrel ) const

## wsphere() [1/2]

ImageRegion * casacore::RegionManager::wsphere | ( | const Vector< Quantity > & | center,
|  | const Quantity & | radius,
|  | const Vector< Int > & | pixelaxes,
|  | const CoordinateSystem & | csys,
|  | const String & | absrel )

static

## wsphere() [2/2]

ImageRegion * casacore::RegionManager::wsphere | ( | const Vector< Quantity > & | center,
|  | const Quantity & | radius,
|  | const Vector< Int > & | pixelaxes,
|  | const String & | absrel ) const

wsphere version without csys...throws an exception if setcoordsys is not run

## Member Data Documentation

## itsCSys

std::unique_ptr<CoordinateSystem> casacore::RegionManager::itsCSys

private

Definition at line 262 of file RegionManager.h.

## itsLog

LogIO* casacore::RegionManager::itsLog

private

Definition at line 261 of file RegionManager.h.

Referenced by _getLog().

## tab_p

Table casacore::RegionManager::tab_p

private

Definition at line 267 of file RegionManager.h.

The documentation for this class was generated from the following file:

- images/Regions/RegionManager.h